# @description: a wrapper for R scale function to perform z-score transformation on the data matrix rows or columns;
# @param data: a (non-empty) numeric data matrix.
# @param z.byrow: T: to perform the z-score transformation on rows, otherwise on columns

zscore.transform<-function(data, z.byrow=c(T,F))
{

warning_mssg<-""
error_mssg<-""
wmssg<-""
emssg<-""

exceptions = tryCatch({
                if (z.byrow==T) t(scale(data)) else scale(data)
}, warning = function(war) {
                                warning_mssg<<-war
                }, error = function(err) {
                                error_mssg<<-err
                }, finally = {
                if (z.byrow==T) zscore<-t(scale(t(data))) else zscore<-scale(data)

                })

                zcenter<-attr(zscore,"scaled:center")
                zscale<-attr(zscore,"scaled:scale")
                attr(zscore,"scaled:center")<-NULL
                attr(zscore,"scaled:scale")<-NULL

                if (!is.null(warning_mssg)) wmssg<-sub(" in doTryCatch(return(expr), name, parentenv, handler)", "",warning_mssg, fixed=T) else wmssg<-""
                if (!is.null(error_mssg)) emssg<-sub(" in doTryCatch(return(expr), name, parentenv, handler)", "",error_mssg, fixed=T) else emssg<-""
                list(wmssg=wmssg, emssg=emssg, result=zscore)
}